# 2023-080

**<h2>Automated ER Diagram Generation, Plagiarism Check, and AI-based quiz System</h2>**

* **<h3>Main Objective</h3>**

    Automated ER Diagram Generation, Plagiarism Check, and AI-based quiz System
 
* **<h3>Main Research questions</h3>**

    The real-world problem addressed by this research is the inefficiency and subjectivity of current methods used to assess student assignments that involve designing Entity-Relationship (ER) diagrams.ER diagrams are widely used in various fields such as computer science, business management, and engineering to model data and relationships between entities. Students are often required to create ER diagrams as part of their coursework or assessments. However, manually assessing these diagrams can be a time-consuming and subjective process, especially in large classes with numerous submissions.
    
    Additionally, plagiarism and improper collaboration can be major issues when assessing ER diagram assignments. It can be challenging for instructors to identify cases of plagiarism, and even if detected, it can be difficult to determine the level of collaboration involved and assign appropriate penalties. This can result in unfair outcomes for both honest and dishonest students.
    
    Furthermore, current methods of assessing ER diagrams may not accurately reflect student understanding of the material. For example, an instructor may provide a scenario and ask students to design an ER diagram and SQL queries based on that scenario. However, some students may be able to create a visually appealing diagram and query without fully understanding the underlying concepts, while others may struggle with the visual representation but have a strong grasp of the concepts.
    
    The proposed solution of an automated system that can generate ER diagrams, check for plagiarism, and suggest suitable questions for students to answer based on their ER diagrams and queries addresses these issues by providing a more efficient and objective assessment method. The system can also help instructors identify instances of plagiarism and improper collaboration more easily and accurately, while also providing students with targeted questions that reflect their level of understanding.
    
    Overall, the development of an automated ER diagram and query assessment system has the potential to improve the fairness and efficiency of assessing student assignments in various fields, while also enhancing academic integrity.


* **<h3>Individual research question</h3>**

    **1.	Automated ER Diagram Generation and Query Generation**
    The lengthy and challenging process of building a database schema and producing SQL queries is one of the main difficulties in the field of database management systems. It is challenging for non-technical people to develop databases and interact with them because this process necessitates a large amount of technical knowledge and skill. Even technically proficient consumers frequently find the process difficult and time-consuming. 
    
    A system that can automatically extract crucial information from natural language scenarios and produce an entity-relationship (ER) diagram, a database schema and SQL queries for the same scenario is needed to address this problem. Because there isn't a complete system in place to do this automatically yet, the procedure is still rather manual and time-consuming.
    
    The suggested approach tries to establish a system that can minimize user engagement, cut down on time spent on tasks, and still allow non-technical people to create databases and interact with them. The system will combine methods like machine learning and natural language processing (NLP) to automatically extract pertinent data from natural language scenarios and provide an ER diagram and a structured representation of the database schema. The solution will leverage the database structure and ER diagram to automatically construct SQL queries, enabling users to communicate with the database using a natural language interface. 
    
    In comparison to the present manual database design procedure, the suggested approach will provide a number of benefits. First of all, it will considerably shorten the time needed to create SQL queries and design databases. The second benefit is that it will make it less complicated and more approachable for non-technical people. The final benefit is that it will lessen mistakes and inconsistencies that could result from manual database construction. 
    
    In conclusion, a fundamental difficulty in the field of database management systems is the lack of a full system that can automatically extract relevant features from natural language scenarios and build an ER diagram, a database design, and SQL queries for the same scenario. The method being developed to address this problem seeks to reduce user engagement and time requirements while still enabling non-technical people to create databases and interact with them.


* **<h3>Individual Objectives</h3>**
 
* **<h3>Other necessary information</h3>**
